import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:get/get.dart';

import 'progress_bloc.dart'; 

class WidgetProgressBuilder extends StatelessWidget {
  final Widget Function(Map progress) builder;
  const WidgetProgressBuilder({
    Key? key,
    required this.builder,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ProgressBloc, ProgressState>(
      bloc: Get.find<ProgressBloc>(),
      builder: (_, state) {
        return builder(state.progress);
      },
    );
  }
}
