import '../resources.dart';
import 'calm_cate.dart';

class CalmModel {
  String? id;
  String? calmName;
  String? pictureUrl;
  String? videoUrl;
  dynamic? datetime;
  int? isUniversal;
  int? cardType;
  int? duration;
  double? price;
  String? currency;
  int? freeSampleFrom;
  int? freeSampleTo;
  dynamic? rating;
  int? numberOfSubscriber;
  CalmSubscriber? creator;
  CalmCate? category;

  CalmModel(
      {this.id,
      this.calmName,
      this.pictureUrl,
      this.videoUrl,
      this.datetime,
      this.isUniversal,
      this.cardType,
      this.duration,
      this.price,
      this.currency,
      this.freeSampleFrom,
      this.freeSampleTo,
      this.rating,
      this.numberOfSubscriber,
      this.creator,
      this.category});

  CalmModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is String) this.id = json["id"];
    if (json["calmName"] is String) this.calmName = json["calmName"];
    if (json["pictureUrl"] is String) this.pictureUrl = json["pictureUrl"];
    if (json["videoUrl"] is String) this.videoUrl = json["videoUrl"];
    this.datetime = json["datetime"];
    if (json["isUniversal"] is int) this.isUniversal = json["isUniversal"];
    if (json["cardType"] is int) this.cardType = json["cardType"];
    if (json["duration"] is int) this.duration = json["duration"];
    if (json["price"] is double) this.price = json["price"];
    if (json["currency"] is String) this.currency = json["currency"];
    if (json["freeSampleFrom"] is int)
      this.freeSampleFrom = json["freeSampleFrom"];
    if (json["freeSampleTo"] is int) this.freeSampleTo = json["freeSampleTo"];
    this.rating = json["rating"];
    if (json["numberOfSubscriber"] is int)
      this.numberOfSubscriber = json["numberOfSubscriber"];
    if (json["category"] is Map)
      this.category =
          json["category"] == null ? null : CalmCate.fromJson(json["category"]);
    if (json["creator"] is Map)
      this.creator = json["creator"] == null
          ? null
          : CalmSubscriber.fromJson(json["category"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["calmName"] = this.calmName;
    data["pictureUrl"] = this.pictureUrl;
    data["videoUrl"] = this.videoUrl;
    data["datetime"] = this.datetime;
    data["isUniversal"] = this.isUniversal;
    data["cardType"] = this.cardType;
    data["duration"] = this.duration;
    data["price"] = this.price;
    data["currency"] = this.currency;
    data["freeSampleFrom"] = this.freeSampleFrom;
    data["freeSampleTo"] = this.freeSampleTo;
    data["rating"] = this.rating;
    data["numberOfSubscriber"] = this.numberOfSubscriber;
    data["creator"] = this.creator?.toJson();
    if (this.category != null) data["category"] = this.category?.toJson();
    return data;
  }
}
