import 'package:device_calendar/device_calendar.dart';
import 'package:flip_card/flip_card.dart';
import 'package:flutter/material.dart';
import 'package:oowoo_core/oowoo_core.dart';

import 'model.dart';

class CalendarChipModel {
  List<CardModel> chipEvents;
  Calendar calendar;
  int eventCount;
  bool select;
  CalendarChipModel({
    required this.calendar,
    required this.chipEvents,
    this.select = true,
    this.eventCount = 0,
  });
}

enum VideoCallEventStatus {
  waitingCall,
  incomingCall,
  calling,
  endCall,
  cancel
}

abstract class CardState<T extends StatefulWidget> extends State<T> {
  void notificationFromServer(data);

  void changedVideoCallStatus(status);
}

class CardModel {
  final Color color;
  final GlobalKey<FlipCardState> key;
  final GlobalKey<CardState> cardKey;
  final GlobalKey<SnappableState> keySnappableState =
      GlobalKey<SnappableState>();
  final int cardType;
  final String title;
  final DateTime start;
  final DateTime? end;
  final DateTime? realStart;
  final String id;
  final String calendarID;
  final String calendarName;
  dynamic cardData;
  Event? calendarEvent;
  String? pathImageEvent;
  bool isMemoryCard = false;
  bool isReminderCard = false;
  ReminderScheduled? reminderScheduled;
  CalmModel? calmModel;
  int maxDelayCancel;
  int? delayValue;
  VideoCallEventStatus videoCallEventStatus = VideoCallEventStatus.waitingCall;

  CardModel({
    required this.id,
    required this.key,
    required this.cardKey,
    required this.start,
    this.color = Colors.white,
    this.calendarID = '',
    this.calendarEvent,
    this.isMemoryCard = false,
    this.isReminderCard = false,
    this.reminderScheduled,
    this.calmModel,
    this.pathImageEvent,
    this.calendarName = '',
    this.title = '',
    this.end,
    this.cardData,
    this.maxDelayCancel = 0,
    this.realStart,
    this.cardType = CT_ERROR,
    this.delayValue,
  });
}
