class CardStripeModel {
  int? cardId;
  int? paymentCustomerId;
  String? cardHolderName;
  String? cardBrand;
  int? cardExpMonth;
  int? cardExpYear;
  String? cardLast4;
  int? timestamp;
  String? gateway;
  String? cardNumber;
  String? cardCVC;
  late bool setAsDefault;

  double positionY = 0;
  double rotate = 0;
  double scale = 0;
  bool isNewCard = false;

  CardStripeModel(
      {this.cardId,
      this.paymentCustomerId,
      this.cardHolderName,
      this.cardBrand,
      this.cardExpMonth,
      this.cardExpYear,
      this.cardLast4,
      this.timestamp,
      this.gateway,
      this.cardNumber,
      this.cardCVC,
      this.setAsDefault = false,
      this.isNewCard = false});

  CardStripeModel.fromJson(Map<String, dynamic> json) {
    cardId = json['cardId'];
    paymentCustomerId = json['paymentCustomerId'];
    cardHolderName = json['cardHolderName'] ?? '';
    cardBrand = json['cardBrand'] ?? '';
    cardExpMonth = json['cardExpMonth'];
    cardExpYear = json['cardExpYear'];
    if (cardExpYear! > 2000) {
      cardExpYear = cardExpYear! % 2000;
    }
    cardLast4 = json['cardLast4'];
    timestamp = json['timestamp'];
    gateway = json['gateway'];
    cardNumber = json['cardNumber'];
    cardCVC = json['cardCVC'];
    setAsDefault = json['setAsDefault'] == 1;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['cardId'] = this.cardId;
    data['paymentCustomerId'] = this.paymentCustomerId;
    data['cardHolderName'] = this.cardHolderName;
    data['cardBrand'] = this.cardBrand;
    data['cardExpMonth'] = this.cardExpMonth;
    data['cardExpYear'] = this.cardExpYear;
    data['cardLast4'] = this.cardLast4;
    data['timestamp'] = this.timestamp;
    data['gateway'] = this.gateway;
    data['setAsDefault'] = this.setAsDefault;
    return data;
  }

  Map<String, dynamic> toJsonForAdd() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['cardHolderName'] = this.cardHolderName;
    data['cardExpMonth'] = this.cardExpMonth;
    data['cardExpYear'] = this.cardExpYear;
    data['cardNumber'] = this.cardNumber;
    data['cardCVC'] = this.cardCVC;
    data['setAsDefault'] = this.setAsDefault;
    return data;
  }
}
