class HomelidoPropertyInfo {
  int? id;
  String? title;
  String? content;
  String? image;
  String? bannerImage;
  String? address;
  double? lat;
  double? lng;
  int? isFeatured;
  List<String>? gallery;
  String? video;
  double? price;
  double? salePrice;
  int? bed;
  int? square;
  int? garages;
  int? area;
  dynamic? areaUnit;
  String? deposit;
  String? poolSize;
  int? propertyType;
  String? status;
  int? defaultState;
  int? view;
  dynamic? recentView;
  dynamic? isSold;
  dynamic? placeId;
  dynamic? expiredAt;
  int? bathroom;
  String? currency;
  String? energyLabel;
  Category? category;
  Owner? owner;

  HomelidoPropertyInfo(
      {this.id,
      this.title,
      this.content,
      this.image,
      this.bannerImage,
      this.address,
      this.lat,
      this.lng,
      this.isFeatured,
      this.gallery,
      this.video,
      this.price,
      this.salePrice,
      this.bed,
      this.square,
      this.garages,
      this.area,
      this.areaUnit,
      this.deposit,
      this.poolSize,
      this.propertyType,
      this.status,
      this.defaultState,
      this.view,
      this.recentView,
      this.isSold,
      this.placeId,
      this.expiredAt,
      this.bathroom,
      this.currency,
      this.energyLabel,
      this.category,
      this.owner});

  HomelidoPropertyInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["title"] is String) this.title = json["title"];
    if (json["content"] is String) this.content = json["content"];
    if (json["image"] is String) this.image = json["image"];
    if (json["bannerImage"] is String) this.bannerImage = json["bannerImage"];
    if (json["address"] is String) this.address = json["address"];
    if (json["lat"] is double)
      this.lat = json["lat"];
    else
      this.lat = 0.0;
    if (json["lng"] is double)
      this.lng = json["lng"];
    else
      this.lng = 0.0;
    if (json["isFeatured"] is int) this.isFeatured = json["isFeatured"];
    if (json["gallery"] is List)
      this.gallery =
          json["gallery"] == null ? null : List<String>.from(json["gallery"]);
    if (json["video"] is String) this.video = json["video"];
    if (json["price"] is double) this.price = json["price"];
    if (json["salePrice"] is double) this.salePrice = json["salePrice"];
    if (json["bed"] is int) this.bed = json["bed"];
    if (json["square"] is int) this.square = json["square"];
    if (json["garages"] is int) this.garages = json["garages"];
    if (json["area"] is int) this.area = json["area"];
    this.areaUnit = json["areaUnit"];
    if (json["deposit"] is String) this.deposit = json["deposit"];
    if (json["poolSize"] is String) this.poolSize = json["poolSize"];
    if (json["propertyType"] is int) this.propertyType = json["propertyType"];
    if (json["status"] is String) this.status = json["status"];
    if (json["defaultState"] is int) this.defaultState = json["defaultState"];
    if (json["view"] is int) this.view = json["view"];
    this.recentView = json["recentView"];
    this.isSold = json["isSold"];
    this.placeId = json["placeId"];
    this.expiredAt = json["expiredAt"];
    if (json["bathroom"] is int) this.bathroom = json["bathroom"];
    if (json["currency"] is String) this.currency = json["currency"];
    if (json["energyLabel"] is String) this.energyLabel = json["energyLabel"];
    if (json["category"] is Map)
      this.category =
          json["category"] == null ? null : Category.fromJson(json["category"]);
    if (json["owner"] is Map)
      this.owner = json["owner"] == null ? null : Owner.fromJson(json["owner"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["title"] = this.title;
    data["content"] = this.content;
    data["image"] = this.image;
    data["bannerImage"] = this.bannerImage;
    data["address"] = this.address;
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    data["isFeatured"] = this.isFeatured;
    if (this.gallery != null) data["gallery"] = this.gallery;
    data["video"] = this.video;
    data["price"] = this.price;
    data["salePrice"] = this.salePrice;
    data["bed"] = this.bed;
    data["square"] = this.square;
    data["garages"] = this.garages;
    data["area"] = this.area;
    data["areaUnit"] = this.areaUnit;
    data["deposit"] = this.deposit;
    data["poolSize"] = this.poolSize;
    data["propertyType"] = this.propertyType;
    data["status"] = this.status;
    data["defaultState"] = this.defaultState;
    data["view"] = this.view;
    data["recentView"] = this.recentView;
    data["isSold"] = this.isSold;
    data["placeId"] = this.placeId;
    data["expiredAt"] = this.expiredAt;
    data["bathroom"] = this.bathroom;
    data["currency"] = this.currency;
    data["energyLabel"] = this.energyLabel;
    if (this.category != null) data["category"] = this.category?.toJson();
    if (this.owner != null) data["owner"] = this.owner?.toJson();
    return data;
  }
}

class Owner {
  String? uniqueId;
  String? firebaseId;

  Owner({this.uniqueId, this.firebaseId});

  Owner.fromJson(Map<String, dynamic> json) {
    if (json["uniqueId"] is String) this.uniqueId = json["uniqueId"];
    if (json["firebaseId"] is String) this.firebaseId = json["firebaseId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["uniqueId"] = this.uniqueId;
    data["firebaseId"] = this.firebaseId;
    return data;
  }
}

class Category {
  int? id;
  String? name;
  String? content;
  String? icon;
  String? slug;
  String? status;

  Category(
      {this.id, this.name, this.content, this.icon, this.slug, this.status});

  Category.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["name"] is String) this.name = json["name"];
    if (json["content"] is String) this.content = json["content"];
    if (json["icon"] is String) this.icon = json["icon"];
    if (json["slug"] is String) this.slug = json["slug"];
    if (json["status"] is String) this.status = json["status"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["name"] = this.name;
    data["content"] = this.content;
    data["icon"] = this.icon;
    data["slug"] = this.slug;
    data["status"] = this.status;
    return data;
  }
}
