class MoveModel {
  int? id;
  String? title;
  String? slug;
  dynamic? content;
  String? address;
  String? video;
  double? lat;
  double? lng;
  dynamic? distance;
  int? isFeatured;
  int? priceRange;
  int? reviewScore;
  dynamic? logoUrl;
  dynamic? qrCode;
  String? image;
  String? bannerImage;
  List<String>? gallery;
  MoviCategory? category;

  MoveModel(
      {this.id,
      this.title,
      this.slug,
      this.content,
      this.address,
      this.video,
      this.lat,
      this.lng,
      this.distance,
      this.isFeatured,
      this.priceRange,
      this.reviewScore,
      this.logoUrl,
      this.qrCode,
      this.image,
      this.bannerImage,
      this.gallery,
      this.category});

  MoveModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["title"] is String) this.title = json["title"];
    if (json["slug"] is String) this.slug = json["slug"];
    this.content = json["content"];
    if (json["address"] is String) this.address = json["address"];
    if (json["video"] is String) this.video = json["video"];
    if (json["lat"] is double) this.lat = json["lat"];
    if (json["lng"] is double) this.lng = json["lng"];
    this.distance = json["distance"];
    if (json["isFeatured"] is int) this.isFeatured = json["isFeatured"];
    if (json["priceRange"] is int) this.priceRange = json["priceRange"];
    if (json["reviewScore"] is int) this.reviewScore = json["reviewScore"];
    this.logoUrl = json["logoUrl"];
    this.qrCode = json["qrCode"];
    if (json["image"] is String) this.image = json["image"];
    if (json["bannerImage"] is String) this.bannerImage = json["bannerImage"];
    if (json["gallery"] is List)
      this.gallery =
          json["gallery"] == null ? null : List<String>.from(json["gallery"]);
    if (json["category"] is Map)
      this.category = json["category"] == null
          ? null
          : MoviCategory.fromJson(json["category"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["title"] = this.title;
    data["slug"] = this.slug;
    data["content"] = this.content;
    data["address"] = this.address;
    data["video"] = this.video;
    data["lat"] = this.lat;
    data["lng"] = this.lng;
    data["distance"] = this.distance;
    data["isFeatured"] = this.isFeatured;
    data["priceRange"] = this.priceRange;
    data["reviewScore"] = this.reviewScore;
    data["logoUrl"] = this.logoUrl;
    data["qrCode"] = this.qrCode;
    data["image"] = this.image;
    data["bannerImage"] = this.bannerImage;
    if (this.gallery != null) data["gallery"] = this.gallery;
    if (this.category != null) data["category"] = this.category?.toJson();
    return data;
  }
}

class MoviCategory {
  int? id;
  String? name;

  MoviCategory({this.id, this.name});

  MoviCategory.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["name"] is String) this.name = json["name"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["name"] = this.name;
    return data;
  }
}
