import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:get/get.dart'; 
import 'package:oowoo_core/widgets/widgets.dart';
import '../../oowoo_constant.dart';

class NotificationModel {
  String type;
  String message;
  String sendName;
  int time;
  int expire;
  bool read;
  int id;
  bool expanded = false;
  Map<String, dynamic>? notifiData;

  GlobalKey<ExpandableNotifierState>? expandableKey;
  dynamic? inviteData;

  NotificationModel({
    required this.id,
    required this.type,
    required this.message,
    required this.read,
    required this.time,
    required this.sendName,
    this.expire = 0,
    this.notifiData,
  });

  String getTitle() {
    String title = '';
    // if (type == N_TYPE_BR_UPDATE_INVITE_STATUS) {
    //   title = 'update_status_an_invitation'.tr;
    // } else if (type == N_TYPE_BR_UPDATE_INVITE_INFO) {
    //   title = 'update_info_an_invitation'.tr;
    // } else if (type == N_TYPE_TIMEOUT_CONFIRM) {
    //   String body =
    //       '${notifiData!['proFirstName']} ${notifiData!['proLastName']}';
    //   title = 'time_out_delay_to_confirm'.trParams({'name': body});
    // } else if (type == N_TYPE_ADD_CONTACT) {
    //   title = 'add_in_a_contact_list'.tr;
    // } else if (type == N_TYPE_TIMEOUT_PAYMENT) {
    //   title = 'service_not_paid'.tr;
    // } else if (type == N_TYPE_TICKET) {
    //   if (notifiData!['status'] == T_CONFIRMED_BY_USER ||
    //       notifiData!['status'] == T_CONFIRMED_BY_PRO) {
    //     title = 'New_appointment'.tr;
    //   } else if (notifiData!['status'] == T_WAIT_FOR_USER_CONFIRMATION) {
    //     title = 'Require_confirmation'.tr;
    //   } else if (notifiData!['status'] == T_CANCELED_BY_PRO) {
    //     title = 'Appointment_cancelled'.tr;
    //   } else if (notifiData!['status'] == T_REFUSED_BY_PRO) {
    //     title = 'Appointment_refused'.tr;
    //   } else if (notifiData!['status'] == T_STARTED) {
    //     title = 'Appointment_started'.tr;
    //   } else if (notifiData!['status'] == T_STOPPED) {
    //     title = 'Appointment_stopped'.tr;
    //   } else if (notifiData!['status'] == T_PURCHASED_BY_USER) {
    //     title = 'Payment_success'.tr;
    //   }
    // }
    return title;
  }

  factory NotificationModel.fromMap(map) {
    return NotificationModel(
      id: map['id'] ?? DateTime.now().millisecondsSinceEpoch,
      type: map[N_TYPE] ?? '',
      message: map[N_MESSAGE] ?? '',
      sendName: map[N_SENDER_FULLNAME] ?? 'oowoo',
      time: int.parse(
          (map[TIMESTAMP] ?? DateTime.now().millisecondsSinceEpoch ~/ 1000)
              .toString()),
      read: (map[N_READ] ?? false).toString() != 'false',
      notifiData: map[N_DATA] is Map
          ? map[N_DATA]
          : map[N_DATA] == null
              ? null
              : jsonDecode(map[N_DATA]),
    );
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data[N_TYPE] = this.type;
    data[N_MESSAGE] = this.message;
    data[N_READ] = this.read;
    data[TIMESTAMP] = this.time;
    data[N_SENDER_FULLNAME] = this.sendName;
    if (notifiData != null) data[N_DATA] = jsonEncode(notifiData);
    return data;
  }
}
