import 'dart:developer';

class PeEventModel {
  String? id;
  String? title;
  String? pictureUrl;
  int? datetimeStart;
  int? datetimeStop;
  int? ownerId;
  String? ownerNickName;
  List<PEUsers>? users;

  PeEventModel(
      {this.id,
      this.title,
      this.pictureUrl,
      this.datetimeStart,
      this.datetimeStop,
      this.ownerId,
      this.ownerNickName,
      this.users});

  PeEventModel.fromJson(Map<String, dynamic> json) { 
    if (json["id"] is String) this.id = json["id"];
    if (json["title"] is String) this.title = json["title"];
    if (json["pictureUrl"] is String) this.pictureUrl = json["pictureUrl"];
    if (json["datetimeStart"] is int) this.datetimeStart = json["datetimeStart"];
    if (json["datetimeStop"] is int) this.datetimeStop = json["datetimeStop"];
    if (json["ownerId"] is int) this.ownerId = json["ownerId"];
    if (json["ownerNickName"] is String) this.ownerNickName = json["ownerNickName"];
    if (json["users"] is List)
      this.users = json["users"] == null
          ? null
          : (json["users"] as List).map((e) => PEUsers.fromJson(e)).toList();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["title"] = this.title;
    data["pictureUrl"] = this.pictureUrl;
    data["datetimeStart"] = this.datetimeStart;
    data["datetimeStop"] = this.datetimeStop;
    data["ownerId"] = this.ownerId;
    data["ownerNickName"] = this.ownerNickName;
    if (this.users != null) data["users"] = this.users?.map((e) => e.toJson()).toList();
    return data;
  }
}

class PEUsers {
  int? id;
  String? nickName;
  String? thumbnail;

  PEUsers({this.id, this.nickName, this.thumbnail});

  PEUsers.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["nickName"] is String) this.nickName = json["nickName"];
    if (json["thumbnail"] is String) this.thumbnail = json["thumbnail"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["nickName"] = this.nickName;
    data["thumbnail"] = this.thumbnail;
    return data;
  }
}
