class PlaceModel {
  late String country;
  late String label;
  late int placeCatID;
  late String informations;
  late int oowoo;
  late String street1;
  late String phone;
  late String street2;
  late String uniqueID;
  late String phoneCode;
  late String zip;
  late int proID;
  late int privacyEnforced;
  late String city;
  late String utcModifier;
  late String state;
  late int id;
  late double lat;
  late double lng;

  PlaceModel({
    required this.country,
    required this.label,
    required this.placeCatID,
    required this.informations,
    required this.oowoo,
    required this.street1,
    required this.phone,
    required this.street2,
    required this.uniqueID,
    required this.phoneCode,
    required this.zip,
    required this.proID,
    required this.privacyEnforced,
    required this.city,
    required this.utcModifier,
    required this.state,
    required this.id,
    required this.lat,
    required this.lng,
  });

  PlaceModel.fromJson(Map<String, dynamic> json) {
    country = json['country'] ?? '';
    label = json['label'] ?? '';
    placeCatID = json['placeCatId'] ?? 0;
    informations = json['informations'] ?? '';
    oowoo = json['oowoo'] ?? 0;
    street1 = json['street1'] ?? '';
    phone = json['phone'] ?? '';
    street2 = json['street2'] ?? '';
    uniqueID = json['uniqueId'] ?? '';
    phoneCode = json['phoneCode'] ?? '';
    zip = json['zip'] ?? '';
    proID = json['proId'] ?? 0;
    privacyEnforced = json['privacyEnforced'] ?? 0;
    city = json['city'] ?? '';
    utcModifier = json['utcModifier'] ?? '';
    state = json['state'] ?? '';
    id = json['id'] ?? 0;
    lat = json['lat'] ?? 0;
    lng = json['lng'] ?? 0;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['country'] = this.country;
    data['label'] = this.label;
    data['placeCatId'] = this.placeCatID;
    data['informations'] = this.informations;
    data['oowoo'] = this.oowoo;
    data['street1'] = this.street1;
    data['phone'] = this.phone;
    data['street2'] = this.street2;
    data['uniqueID'] = this.uniqueID;
    data['phoneCode'] = this.phoneCode;
    data['zip'] = this.zip;
    data['proId'] = this.proID;
    data['privacyEnforced'] = this.privacyEnforced;
    data['city'] = this.city;
    data['utcModifier'] = this.utcModifier;
    data['state'] = this.state;
    data['id'] = this.id;
    data['lat'] = this.lat;
    data['lng'] = this.lng;
    return data;
  }

  String toAddressString() {
    return (street1.isNotEmpty ? "$street1, " : "") + (city.isNotEmpty ? "$city, " : "") + country;
  }

  String toAddress2String() {
    if (zip.isNotEmpty)
      return '$street1\n$zip $city\n$country';
    else
      return '$street1\n$city\n$country';
  }

  String toAddress3String() {
    return '$country\n$zip $city\n$street1';
  }
}
