import 'dart:convert';

class ProInfo {
  int? id;
  String? firebaseId;
  String? token;
  String? uniqueId;
  String? firstName;
  String? companyName;
  String? lastName;
  String? displayName;
  String? website;
  String? categorie;
  String? profession;
  String? rating;
  String? email;
  String? phone1;
  String? phone2;
  String? street1;
  String? street2;
  String? zip;
  String? city;
  String? state;
  String? country;
  String? colorCode;
  String? thumbnail;
  int? createdAt;
  int? signedAt;
  String? linkedin;
  String? google;
  String? facebook;
  String? twitter;
  String? pinterest;
  String? aboutMe;
  String? proPictureUrl;
  int? google2FaFlg;
  String? google2FaSecretKey;
  int? usedStorageSpace;
  String? gender;
  String? ageRange;
  String? phoneCode;
  String? subscriptionPlanId;
  int? allowChat;
  int? smsAllowed;
  int? proType;
  String? planName;
  String? mainLanguage;
  int? reliability;
  List<String>? secondaryLanguages;
  int? isHomelidoAgent;
  int? timeBeforeStartTracking;
  String? interfaceLanguageCode;
  dynamic distanceBeforeStartTracking;
  int? allowGeolocation;
  String? dateFormat;
  String? timeFormat;
  
  String get fullName => '${firstName} ${lastName}';

  ProInfo({
    this.id,
    this.firebaseId,
    this.token,
    this.uniqueId,
    this.firstName,
    this.companyName,
    this.lastName,
    this.displayName,
    this.website,
    this.categorie,
    this.profession,
    this.rating,
    this.email,
    this.phone1,
    this.phone2,
    this.street1,
    this.street2,
    this.zip,
    this.city,
    this.state,
    this.country,
    this.colorCode,
    this.thumbnail = '',
    this.createdAt,
    this.signedAt,
    this.linkedin,
    this.google,
    this.facebook,
    this.twitter,
    this.pinterest,
    this.aboutMe,
    this.proPictureUrl,
    this.google2FaFlg,
    this.google2FaSecretKey,
    this.usedStorageSpace,
    this.gender,
    this.ageRange,
    this.phoneCode,
    this.subscriptionPlanId,
    this.allowChat,
    this.smsAllowed,
    this.proType,
    this.planName,
    this.mainLanguage,
    this.reliability,
    this.secondaryLanguages,
    this.isHomelidoAgent,
    this.timeBeforeStartTracking,
    this.interfaceLanguageCode,
    this.distanceBeforeStartTracking,
    this.allowGeolocation,
    this.dateFormat,
    this.timeFormat,
  });

  ProInfo.fromJson(Map<String, dynamic> json) {
    try {
      id = json['id'];
      firebaseId = json['firebaseId'];
      token = json['token'];
      uniqueId = json['uniqueId'];
      firstName = json['firstName'];
      companyName = json['companyName'];
      lastName = json['lastName'];
      displayName = json['displayName'];
      website = json['website'];
      categorie = json['categorie'];
      profession = json['profession'];
      rating = json['rating'];
      email = json['email'];
      phone1 = json['phone1'];
      phone2 = json['phone2'];
      street1 = json['street1'];
      street2 = json['street2'];
      zip = json['zip'];
      city = json['city'];
      state = json['state'];
      country = json['country'];
      colorCode = json['colorCode'];
      thumbnail = json['thumbnail'];
      createdAt = json['createdAt'];
      signedAt = json['signedAt'];
      linkedin = json['linkedin'];
      google = json['google'];
      facebook = json['facebook'];
      twitter = json['twitter'];
      pinterest = json['pinterest'];
      aboutMe = json['aboutMe'];
      proPictureUrl = json['proPictureUrl'];
      google2FaFlg = json['google2FaFlg'];
      google2FaSecretKey = json['google2FaSecretKey'];
      usedStorageSpace = json['usedStorageSpace'];
      gender = json['gender'];
      ageRange = json['ageRange'];
      phoneCode = json['phoneCode'];
      subscriptionPlanId = json['subscriptionPlanId'];
      allowChat = json['allowChat'];
      smsAllowed = json['smsAllowed'];
      proType = json['proType'];
      planName = json['planName'];
      mainLanguage = json['mainLanguage'];
      reliability = json['reliability'];
      secondaryLanguages = json['secondaryLanguages'] != null
          ? json['secondaryLanguages'] is List
              ? (json['secondaryLanguages'] as List)
                  .map((e) => e.toString())
                  .toList()
              : jsonDecode(jsonEncode(json['secondaryLanguages']))
          : [];
      isHomelidoAgent = json['isHomelidoAgent'] ?? 0;
      timeBeforeStartTracking = json['timeBeforeStartTracking'] ?? 0;
      interfaceLanguageCode = json['interfaceLanguageCode'];
      distanceBeforeStartTracking = json['distanceBeforeStartTracking'] ?? 0.0;
      allowGeolocation = json['allowGeolocation'];
      dateFormat = json['dateFormat'];
      timeFormat = json['timeFormat'];
    } catch (ex) {}
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['firebaseId'] = this.firebaseId;
    data['token'] = this.token;
    data['uniqueId'] = this.uniqueId;
    data['firstName'] = this.firstName;
    data['companyName'] = this.companyName;
    data['lastName'] = this.lastName;
    data['displayName'] = this.displayName;
    data['website'] = this.website;
    data['categorie'] = this.categorie;
    data['profession'] = this.profession;
    data['rating'] = this.rating;
    data['email'] = this.email;
    data['phone1'] = this.phone1;
    data['phone2'] = this.phone2;
    data['street1'] = this.street1;
    data['street2'] = this.street2;
    data['zip'] = this.zip;
    data['city'] = this.city;
    data['state'] = this.state;
    data['country'] = this.country;
    data['colorCode'] = this.colorCode;
    data['thumbnail'] = this.thumbnail;
    data['createdAt'] = this.createdAt;
    data['signedAt'] = this.signedAt;
    data['linkedin'] = this.linkedin;
    data['google'] = this.google;
    data['facebook'] = this.facebook;
    data['twitter'] = this.twitter;
    data['pinterest'] = this.pinterest;
    data['aboutMe'] = this.aboutMe;
    data['proPictureUrl'] = this.proPictureUrl;
    data['google2FaFlg'] = this.google2FaFlg;
    data['google2FaSecretKey'] = this.google2FaSecretKey;
    data['usedStorageSpace'] = this.usedStorageSpace;
    data['gender'] = this.gender;
    data['ageRange'] = this.ageRange;
    data['phoneCode'] = this.phoneCode;
    data['subscriptionPlanId'] = this.subscriptionPlanId;
    data['allowChat'] = this.allowChat;
    data['smsAllowed'] = this.smsAllowed;
    data['proType'] = this.proType;
    data['planName'] = this.planName;
    data['mainLanguage'] = this.mainLanguage;
    data['reliability'] = this.reliability;
    data['secondaryLanguages'] = this.secondaryLanguages;
    data['isHomelidoAgent'] = this.isHomelidoAgent;
    data['timeBeforeStartTracking'] = this.timeBeforeStartTracking;
    data['interfaceLanguageCode'] = this.interfaceLanguageCode;
    data['distanceBeforeStartTracking'] = this.distanceBeforeStartTracking;
    data['allowGeolocation'] = this.allowGeolocation;
    data['dateFormat'] = dateFormat;
    data['timeFormat'] = timeFormat;
    return data;
  }
}

class GetProDetailModel {
  GetProDetailModel({
    required this.proInfo,
  });

  ProInfo proInfo;

  factory GetProDetailModel.fromJson(Map<String, dynamic> json) =>
      GetProDetailModel(
        proInfo: ProInfo.fromJson(json["values"]),
      );

  Map<String, dynamic> toJson() => {
        "values": proInfo.toJson(),
      };
}
