/// id : 0
/// title : "string"
/// thumbnail : "string"
/// venueName : "string"
/// lat : 0
/// lng : 0
/// street1 : "string"
/// state : "string"
/// city : "string"
/// country : "string"
/// flagCode : "string"
/// startDateTime : 0
/// stopDateTime : 0
/// utcModifier : "string"
/// colorCode : "string"
/// colorCode2 : "string"
/// catName : "string"
/// isLiked : 0
/// isBooked : 0
/// numberLikedUsers : 0
/// numberBookedUsers : 0
/// bookedUsers : [{"userId":0,"thumbnail":"string","nickName":"string","createdAt":0}]

class PublishEvent {
  PublishEvent({
    this.id,
    this.title,
    this.subTitle,
    this.thumbnail,
    this.venueName,
    this.lat,
    this.lng,
    this.street1,
    this.state,
    this.city,
    this.country,
    this.zip,
    this.flagCode,
    this.startDateTime,
    this.stopDateTime,
    this.utcModifier,
    this.colorCode,
    this.colorCode2,
    this.catName,
    this.isLiked,
    this.isBooked,
    this.numberLikedUsers,
    this.numberBookedUsers,
    this.bookedUsers,
  });

  PublishEvent.fromJson(dynamic json) {
    id = json['id'];
    title = json['title'];
    subTitle = json['subtitle'];
    thumbnail = json['thumbnail'];
    venueName = json['venueName'];
    lat = json['lat'];
    lng = json['lng'];
    street1 = json['street1'];
    state = json['state'];
    city = json['city'];
    country = json['country'];
    zip = json['zip'];
    flagCode = json['flagCode'];
    startDateTime = json['startDateTime'];
    stopDateTime = json['stopDateTime'];
    utcModifier = json['utcModifier'];
    colorCode = json['colorCode'];
    colorCode2 = json['colorCode2'];
    catName = json['catName'];
    isLiked = json['isLiked'];
    isBooked = json['isBooked'];
    numberLikedUsers = json['numberLikedUsers'];
    numberBookedUsers = json['numberBookedUsers'];
    if (json['bookedUsers'] != null) {
      bookedUsers = [];
      json['bookedUsers'].forEach((v) {
        bookedUsers?.add(BookedUsers.fromJson(v));
      });
    }
  }

  int? id;
  String? title;
  String? subTitle;
  String? thumbnail;
  String? venueName;
  double? lat;
  double? lng;
  String? street1;
  String? state;
  String? city;
  String? country;
  String? zip;
  String? flagCode;
  int? startDateTime;
  int? stopDateTime;
  String? utcModifier;
  String? colorCode;
  String? colorCode2;
  String? catName;
  int? isLiked;
  int? isBooked;
  int? numberLikedUsers;
  int? numberBookedUsers;
  List<BookedUsers>? bookedUsers;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['id'] = id;
    map['title'] = title;
    map['subTitle'] = subTitle;
    map['subTitle'] = subTitle;
    map['thumbnail'] = thumbnail;
    map['venueName'] = venueName;
    map['lat'] = lat;
    map['lng'] = lng;
    map['street1'] = street1;
    map['state'] = state;
    map['city'] = city;
    map['country'] = country;
    map['zip'] = zip;
    map['flagCode'] = flagCode;
    map['startDateTime'] = startDateTime;
    map['stopDateTime'] = stopDateTime;
    map['utcModifier'] = utcModifier;
    map['colorCode'] = colorCode;
    map['colorCode2'] = colorCode2;
    map['catName'] = catName;
    map['isLiked'] = isLiked;
    map['isBooked'] = isBooked;
    map['numberLikedUsers'] = numberLikedUsers;
    map['numberBookedUsers'] = numberBookedUsers;
    if (bookedUsers != null) {
      map['bookedUsers'] = bookedUsers?.map((v) => v.toJson()).toList();
    }
    return map;
  }
}

/// userId : 0
/// thumbnail : "string"
/// nickName : "string"
/// createdAt : 0

class BookedUsers {
  BookedUsers({
    this.userId,
    this.thumbnail,
    this.nickName,
    this.createdAt,
  });

  BookedUsers.fromJson(dynamic json) {
    userId = json['userId'];
    thumbnail = json['thumbnail'];
    nickName = json['nickName'];
    createdAt = json['createdAt'];
  }

  int? userId;
  String? thumbnail;
  String? nickName;
  int? createdAt;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['userId'] = userId;
    map['thumbnail'] = thumbnail;
    map['nickName'] = nickName;
    map['createdAt'] = createdAt;
    return map;
  }
}
