import 'model.dart';

class PurchaseInfo {
  int? id;
  int? type;
  String? userUniqueId;
  String? proUniqueId;
  String? qrCode;
  String? paymentMethod;
  PaymentMethodInfo? paymentMethodInfo;
  String? countryCode;
  String? currency;
  double? amount;
  int? commissionId;
  String? status;
  String? error;
  int? timestamp;
  int? purchasedAt;
  int? deliveryLocationId;
  String? transactionFriendlyId;
  int? fromShop;
  String? gateway;
  String? orderId;
  String? eventUniqueId;

  PurchaseInfo(
      {this.id,
      this.type,
      this.userUniqueId,
      this.proUniqueId,
      this.qrCode,
      this.paymentMethod,
      this.paymentMethodInfo,
      this.countryCode,
      this.currency,
      this.amount,
      this.commissionId,
      this.status,
      this.error,
      this.timestamp,
      this.purchasedAt,
      this.deliveryLocationId,
      this.transactionFriendlyId,
      this.fromShop,
      this.gateway,
      this.orderId,
      this.eventUniqueId});

  PurchaseInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["type"] is int) this.type = json["type"];
    if (json["userUniqueId"] is String) this.userUniqueId = json["userUniqueId"];
    if (json["proUniqueId"] is String) this.proUniqueId = json["proUniqueId"];
    if (json["qrCode"] is String) this.qrCode = json["qrCode"];
    if (json["paymentMethod"] is String) this.paymentMethod = json["paymentMethod"];
    if (json["paymentMethodInfo"] is Map)
      this.paymentMethodInfo = json["paymentMethodInfo"] == null
          ? null
          : PaymentMethodInfo.fromJson(json["paymentMethodInfo"]);
    if (json["countryCode"] is String) this.countryCode = json["countryCode"];
    if (json["currency"] is String) this.currency = json["currency"];
    if (json["amount"] is double) this.amount = json["amount"];
    if (json["commissionId"] is int) this.commissionId = json["commissionId"];
    if (json["status"] is String) this.status = json["status"];
    if (json["error"] is String) this.error = json["error"];
    if (json["timestamp"] is int) this.timestamp = json["timestamp"];
    if (json["purchasedAt"] is int) this.purchasedAt = json["purchasedAt"];
    if (json["deliveryLocationId"] is int) this.deliveryLocationId = json["deliveryLocationId"];
    if (json["transactionFriendlyId"] is String)
      this.transactionFriendlyId = json["transactionFriendlyId"];
    if (json["fromShop"] is int) this.fromShop = json["fromShop"];
    if (json["gateway"] is String) this.gateway = json["gateway"];
    if (json["orderId"] is String) this.orderId = json["orderId"];
    if (json["eventUniqueId"] is String) this.eventUniqueId = json["eventUniqueId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["type"] = this.type;
    data["userUniqueId"] = this.userUniqueId;
    data["proUniqueId"] = this.proUniqueId;
    data["qrCode"] = this.qrCode;
    data["paymentMethod"] = this.paymentMethod;
    if (this.paymentMethodInfo != null)
      data["paymentMethodInfo"] = this.paymentMethodInfo?.toJson();
    data["countryCode"] = this.countryCode;
    data["currency"] = this.currency;
    data["amount"] = this.amount;
    data["commissionId"] = this.commissionId;
    data["status"] = this.status;
    data["error"] = this.error;
    data["timestamp"] = this.timestamp;
    data["purchasedAt"] = this.purchasedAt;
    data["deliveryLocationId"] = this.deliveryLocationId;
    data["transactionFriendlyId"] = this.transactionFriendlyId;
    data["fromShop"] = this.fromShop;
    data["gateway"] = this.gateway;
    data["orderId"] = this.orderId;
    data["eventUniqueId"] = this.eventUniqueId;
    return data;
  }
}
 