import 'package:flutter/material.dart';
import 'package:oowoo_core/oowoo_core.dart';

class MissionTypeModel {
  int? id;
  String? missionTypeName;
  String? instruction;
  dynamic? shortDescription;
  String? teaserVideoUrl;
  String? tutoMissionTypeVideoUrl;
  String? tutoSellerVideoUrl;
  String? pictureUrl;
  String? colorCode;
  GlobalKey<ExpandableNotifierState> expandableKey =
      GlobalKey<ExpandableNotifierState>();
  dynamic stateKey = GlobalKey();

  Color? get color {
    if (colorCode != null) return hexColor(colorCode!);
  }

  MissionTypeModel(
      {this.id,
      this.missionTypeName,
      this.instruction,
      this.shortDescription,
      this.teaserVideoUrl,
      this.tutoMissionTypeVideoUrl,
      this.tutoSellerVideoUrl,
      this.pictureUrl,
      this.colorCode});

  MissionTypeModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["missionTypeName"] is String)
      this.missionTypeName = json["missionTypeName"];
    if (json["instruction"] is String) this.instruction = json["instruction"];
    this.shortDescription = json["shortDescription"];
    if (json["teaserVideoUrl"] is String)
      this.teaserVideoUrl = json["teaserVideoUrl"];
    if (json["tutoMissionTypeVideoUrl"] is String)
      this.tutoMissionTypeVideoUrl = json["tutoMissionTypeVideoUrl"];
    if (json["tutoSellerVideoUrl"] is String)
      this.tutoSellerVideoUrl = json["tutoSellerVideoUrl"];
    this.pictureUrl = json["pictureUrl"];
    this.colorCode = json["colorCode"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["missionTypeName"] = this.missionTypeName;
    data["instruction"] = this.instruction;
    data["shortDescription"] = this.shortDescription;
    data["teaserVideoUrl"] = this.teaserVideoUrl;
    data["tutoMissionTypeVideoUrl"] = this.tutoMissionTypeVideoUrl;
    data["tutoSellerVideoUrl"] = this.tutoSellerVideoUrl;
    data["pictureUrl"] = this.pictureUrl;
    data["colorCode"] = this.colorCode;
    return data;
  }
}
