import 'package:oowoo_core/utils/utils.dart';

import 'model.dart';

class ServiceAvailabilityModel {
  int? day;
  int? availability;
  int? timestamp;
  DateTime? dateOfMonth;
  List<TimeFrames>? timeFrames;

  List<TimeFrames> get getTimeFramesAvailiable =>
      (timeFrames ?? []).where((e) => e.booking != 1).toList();

  ServiceAvailabilityModel(
      {this.day,
      this.availability,
      this.timestamp,
      this.timeFrames,
      this.dateOfMonth});

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['day'] = this.day;
    data['availability'] = this.availability;
    data['timestamp'] = this.timestamp;
    data['timeFrame'] = this.timeFrames?.map((v) => v.toJson()).toList();
    return data;
  }

  ServiceAvailabilityModel.fromJson(Map<String, dynamic> json) {
    day = json['day'] ?? 0;
    if (json['dateOfMonth'] != null)
      dateOfMonth =
          convertString2DateTime(json['dateOfMonth'], format: 'yyyy-MM-dd');
    availability = json['availability'] ?? 0;
    timestamp = json['timestamp'] ?? 0;
    if (json['timeFrame'] != null) {
      timeFrames = [];
      json['timeFrame'].forEach((v) {
        timeFrames!.add(new TimeFrames.fromJson(v));
      });
    }
  }
}
