import 'package:oowoo_core/oowoo_core.dart';

class UserModel {
  int? id;

  //Use in case get list contact
  int? userId;
  String? firebaseId;
  String? tokenFirebase;
  String? token;
  String? uniqueId;
  String? firstName;
  String? lastName;
  String? nickName;
  String? infoName;
  String? phone;
  String? email;
  String? comment;
  String? thumbnail = '';
  int? blurPicture;
  int? reliability;
  int? createdAt;
  int? signedAt;
  int? allowGeolocation;
  int? oowoo;
  List? fCMTokens;
  int? isTmpEmail;
  int? sellerStatus;
  String? sellerQrCode;
  int? timeBeforeStartTracking;
  dynamic distanceBeforeStartTracking;
  String? interfaceLanguageCode;
  String? dateFormat;
  String? timeFormat;

  String get fullName => '${firstName ?? ''} ${lastName ?? ''}';

  String get firstChar => firstName == null && lastName == null
      ? ''
      : ('${firstName ?? ''}${lastName ?? ''}'.split('').isEmpty
          ? ''
          : '${firstName ?? ''}${lastName ?? ''}'.split('').first);

  bool isNotYetSeller([int? status]) {
    status ??= sellerStatus;
    return status != SELLER_STATUS_WAIT_PASSPORT &&
        status != SELLER_STATUS_WAIT_SELFIE &&
        status != SELLER_STATUS_WAIT_REQUEST &&
        status != SELLER_STATUS_WAIT_APPROVE &&
        status != SELLER_STATUS_IS_SELLER &&
        status != SELLER_STATUS_HAS_QUIT_TMP &&
        status != SELLER_STATUS_HAS_QUIT_FOREVER &&
        status != SELLER_STATUS_IS_REJECTED;
  }

  UserModel({
    this.id,
    this.userId,
    this.firebaseId,
    this.tokenFirebase,
    this.token,
    this.uniqueId,
    this.firstName,
    this.lastName,
    this.nickName,
    this.infoName,
    this.phone,
    this.email,
    this.comment,
    this.thumbnail = '',
    this.blurPicture = 0,
    this.reliability = 0,
    this.createdAt = 0,
    this.allowGeolocation = 0,
    this.signedAt = 0,
    this.fCMTokens,
    this.oowoo,
    this.isTmpEmail,
    this.sellerStatus,
    this.sellerQrCode,
    this.timeBeforeStartTracking = 0,
    this.interfaceLanguageCode,
    this.distanceBeforeStartTracking,
    this.dateFormat,
    this.timeFormat,
  });

  UserModel.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    userId = json['userId'];
    firebaseId = json['firebaseId'] ?? '';
    tokenFirebase = json['tokenFirebase'];
    token = json['token'];
    uniqueId = json['uniqueId'];
    firstName = json['firstName'] ?? '';
    lastName = json['lastName'] ?? '';
    nickName = json['nickName'] ?? '';
    infoName = json['infoName'] ?? '';
    phone = json['phone'] ?? '';
    email = json['email'];
    comment = json['comment'];
    thumbnail = json['thumbnail'] ?? '';
    blurPicture = json['blurPicture'];
    reliability = json['reliability'];
    createdAt = json['createdAt'];
    signedAt = json['signedAt'];
    fCMTokens = json['fcmToken'];
    oowoo = json['oowoo'] ?? 0;
    allowGeolocation = json['allowGeolocation'];
    isTmpEmail = json['isTmpEmail'];
    sellerStatus = json['sellerStatus'];
    sellerQrCode = json['sellerQrCode'] ?? "";
    timeBeforeStartTracking = json['timeBeforeStartTracking'] ?? 0;
    interfaceLanguageCode = json['interfaceLanguageCode'];
    distanceBeforeStartTracking = json['distanceBeforeStartTracking'] ?? 0.0;
    dateFormat = json['dateFormat'];
    timeFormat = json['timeFormat'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['oowoo'] = oowoo;
    data['id'] = id;
    data['userId'] = userId;
    data['firebaseId'] = firebaseId;
    data['tokenFirebase'] = tokenFirebase;
    data['token'] = token;
    data['uniqueId'] = uniqueId;
    data['firstName'] = firstName;
    data['lastName'] = lastName;
    data['nickName'] = nickName;
    data['infoName'] = infoName;
    data['phone'] = phone;
    data['email'] = email;
    data['comment'] = comment;
    data['thumbnail'] = thumbnail;
    data['blurPicture'] = blurPicture;
    data['reliability'] = reliability;
    data['createdAt'] = createdAt;
    data['signedAt'] = signedAt;
    data['allowGeolocation'] = allowGeolocation;
    data['isTmpEmail'] = isTmpEmail;
    data['sellerStatus'] = sellerStatus;
    data['sellerQrCode'] = sellerQrCode;
    data['timeBeforeStartTracking'] = timeBeforeStartTracking;
    data['interfaceLanguageCode'] = interfaceLanguageCode;
    data['distanceBeforeStartTracking'] = distanceBeforeStartTracking;
    data['dateFormat'] = dateFormat;
    data['timeFormat'] = timeFormat;
    return data;
  }

  Map<String, dynamic> toJsonSqlite() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['uniqueId'] = this.uniqueId;
    data['firstName'] = this.firstName;
    data['lastName'] = this.lastName;
    data['id'] = this.id;
    data['nickName'] = this.nickName;
    data['firebaseId'] = this.firebaseId;
    data['thumbnail'] = this.thumbnail;
    return data;
  }
}

class GetUserDetailModel {
  GetUserDetailModel({
    required this.userInfo,
  });

  UserModel userInfo;

  factory GetUserDetailModel.fromJson(Map<String, dynamic> json) =>
      GetUserDetailModel(
        userInfo: UserModel.fromJson(json["values"]),
      );

  Map<String, dynamic> toJson() => {
        "values": userInfo.toJson(),
      };
}
