import '../resources.dart';
import 'package:oowoo_core/network_resources/model/model.dart';

class AgoraToken {
  String? token;
  String? appId;

  AgoraToken({
    this.token,
    this.appId,
  });

  AgoraToken.fromJson(Map<String, dynamic> json) {
    if (json["token"] is String) this.token = json["token"];
    if (json["appId"] is String) this.appId = json["appId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["token"] = this.token;
    data["appId"] = this.appId;
    return data;
  }
}

class AgoraRepo {
  AgoraRepo._();

  static AgoraRepo? _instance;

  factory AgoraRepo([AppApi? api]) {
    _instance ??= AgoraRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<AgoraToken?> generateToken(channelName, {expiredTime}) async {
    NetworkResponse response =
        await _api.generateToken(channelName, expiredTime);
    return response.data;
  }
}
