import 'package:oowoo_core/network_resources/model/model.dart';
import '../resources.dart';

class ContactRepo {
  ContactRepo._();

  static ContactRepo? _instance;

  factory ContactRepo([AppApi? api]) {
    _instance ??= ContactRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<UserModel>> getContactsList([params]) async {
    NetworkResponse response = await _api.getContactsList(params);
    return response.data ?? [];
  }

  Future<UserModel?> addUserInContactsList(params) async {
    NetworkResponse response = await _api.addUserInContactsList(params);
    return response.data;
  }

  Future<bool?> updateCommentForContact(params) async {
    NetworkResponse response = await _api.updateCommentForContact(params);
    return response.data ?? false;
  }

  Future<bool> deleteContact(id) async {
    NetworkResponse response = await _api.deleteContact(id);
    return response.data ?? false;
  }

  Future<UserModel?> getExistingUserByPhone(params) async {
    NetworkResponse response = await _api.getExistingUserByPhone(params);
    return response.data;
  }

  Future<bool> checkAndAddNewContact(params) async {
    NetworkResponse response = await _api.checkAndAddNewContact(params);
    return response.data ?? false;
  }
}
