import '../resources.dart';

class DigicodeRepo {
  DigicodeRepo._();

  static DigicodeRepo? _instance;

  factory DigicodeRepo([AppApi? api]) {
    _instance ??= DigicodeRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<CodeModel>> getCodesFromPro(digicodeId) async {
    NetworkResponse response = await _api.getCodesFromPro(digicodeId);
    return response.data ?? [];
  }

  Future<CodeModel?> createCode(params) async {
    NetworkResponse response = await _api.createCode(params);
    return response.data;
  }

  Future<bool> updateLiveCode(params) async {
    NetworkResponse response = await _api.updateLiveCode(params);
    return response.data ?? false;
  }

  Future<bool> shareCodeDigicode(params) async {
    NetworkResponse response = await _api.shareCodeDigicode(params);
    return response.data ?? false;
  }

  Future<bool> deleteLiveCode(params) async {
    NetworkResponse response = await _api.deleteLiveCode(params);
    return response.data ?? false;
  }

  Future<List<DigicodeModel>> getDigicodesFromPro() async {
    NetworkResponse response = await _api.getDigicodesFromPro();
    return response.data ?? [];
  }

  Future<DigicodeModel?> getDigicodeById(id) async {
    NetworkResponse response = await _api.getDigicodeById(id);
    return response.data;
  }

  Future<DigicodeCheck?> checkDigicodeBySerialAndToken(
      productSerial, authcode) async {
    NetworkResponse response =
        await _api.checkDigicodeBySerialAndToken(productSerial, authcode);
    return response.data;
  }

  Future<bool> linkDigicodeToPro(params) async {
    NetworkResponse response = await _api.linkDigicodeToPro(params);
    return response.data ?? false;
  }

  Future<bool> linkDigicodeToProV2(params) async {
    NetworkResponse response = await _api.linkDigicodeToProV2(params);
    return response.data ?? false;
  }

  Future<bool?> checkDigicodeOnline(digicodeId) async {
    NetworkResponse response = await _api.checkDigicodeOnline(digicodeId);
    return response.data;
  }

  Future<bool> unlockDigicode(digicodeId, unlocked) async {
    NetworkResponse response = await _api
        .unlockDigicode({'digicodeId': digicodeId, 'unlocked': unlocked});
    return response.data ?? false;
  }
}
