import 'package:oowoo_core/network_resources/model/model.dart';
import '../resources.dart';

class ProRepo {
  ProRepo._();

  static ProRepo? _instance;

  factory ProRepo([AppApi? api]) {
    _instance ??= ProRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<ProsModel>?> getFavouriteForUser() async {
    NetworkResponse response = await _api.getFavouriteForUser();
    return response.data;
  }

  Future<bool> removeFromFavourite(proId) async {
    NetworkResponse response = await _api.removeFromFavourite(proId);
    return response.data ?? false;
  }

  Future<bool> addToFavourite(proId) async {
    NetworkResponse response = await _api.addToFavourite(proId);
    return response.data ?? false;
  }
}
