import 'package:oowoo_core/theme/theme.dart';
import '../resources.dart';

class RelaxRepo {
  RelaxRepo._();

  static RelaxRepo? _instance;

  factory RelaxRepo([AppApi? api]) {
    _instance ??= RelaxRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<CalmCate>> getCalmCategories() async {
    NetworkResponse response = await _api.getCalmCategories();
    return response.data ?? [];
  }

  Future<List<CalmModel>> getCalmByCat(
      {required categoryId, isUniversal, page = 1, pageSize = 20}) async {
    Map<String, dynamic> params = {
      'languageCode': appPrefs.languageCode,
      'categoryId': categoryId,
      'page': page,
      'pageSize': pageSize,
    };
    if (isUniversal != null) params.addAll({'isUniversal': isUniversal});
    NetworkResponse response = await _api.getCalmByCat(params);
    return response.data ?? [];
  }

  Future<bool> subscribeToCalmId(calmId) async {
    NetworkResponse response = await _api.subscribeToCalmId(calmId);
    return response.data ?? false;
  }

  Future<List<CalmSubscriber>> getSubscribersForCalmId(
      {required calmId, page = 1, pageSize = 20}) async {
    Map<String, dynamic> params = {
      'calmId': calmId,
      'page': page,
      'pageSize': pageSize,
    };
    NetworkResponse response = await _api.getSubscribersForCalmId(params);
    return response.data ?? [];
  }
}
