import 'package:oowoo_core/network_resources/model/terminal.dart';
import '../resources.dart';

class TerminalRepo {
  TerminalRepo._();

  static TerminalRepo? _instance;

  factory TerminalRepo() {
    _instance ??= TerminalRepo._();
    return _instance!;
  }

  final AppApiImp _api = AppApiImp();

  Future<List<Terminal>> getTerminalsFromPro(terminalType) async {
    NetworkResponse response = await _api.getTerminalsFromPro(terminalType);
    return response.data ?? [];
  }

  Future<bool> updateTerminalFromPro(params) async {
    NetworkResponse response = await _api.updateTerminalFromPro(params);
    return response.data ?? false;
  }

  Future<bool> sendPropertyToTerminal(params) async {
    NetworkResponse response = await _api.sendPropertyToTerminal(params);
    return response.data ?? false;
  }

  Future<bool> removePropertyFromTerminal(params) async {
    NetworkResponse response = await _api.removePropertyFromTerminal(params);
    return response.data ?? false;
  }

  Future<bool> linkTerminalToProV2(params) async {
    NetworkResponse response = await _api.linkTerminalToProV2(params);
    return response.data ?? false;
  }
}
