import 'dart:io';
import 'package:dio/dio.dart';
import 'package:firebase_core/firebase_core.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

const int master = -1;
const int oowooAppUser = 1;
const int oowooAppPro = 2;
const int oowooAppUsePlugin = 10;
const int proDashboard = 20;
const int homelidoUserMainWebsiteplatform = 101;
const int PumpMyBeerUser = 105;
const int homelidoPro = 200;
const int homelidoProMainWebsitePlatform = 201;
const int PumpMyBeerPro = 205;
const int ProDashboardArckipelFullVersion = 2000;
const int websiteUSERPolisiN = 100000001;

enum OOWOOPlatform {
  master,
  mobileUser,
  mobilePro,
  pluginWebUser,
  pluginWebPro,
  homelidoPro,
  webPolisinUser,
  proDashboardArckipelFullVersion
}

@immutable
class OOWOOConfigData with Diagnosticable {
  factory OOWOOConfigData({
    required String baseUrl,
    required String baseUrlHomelido,
    required String baseUrlGeotracking,
    required String mqttUrl,
    required int mqttPort,
    Color? mainColor,
    Function(bool permissionStatus)? onAfterLogin,
    dynamic appPrefs,
    dynamic appColors,
    bool? isUserVersion,
    OOWOOPlatform? oowooPlatform,
    Future<File?> Function(
            {TakeFileType fileType, TakeFileTypeAllow fileTypeAllow})?
        takeFile,
    dynamic chatgetPreEventByEventId,
    dynamic chatgetDifferentTimePreEventByEventId,
    dynamic chatgetDistanceBetweenUserAndPlaceByEventId,
    dynamic chatopeninmycalendar,
    dynamic chatgettitleEvent,
    dynamic chatgetcardColor,
    Function(dynamic homelidoId)? chatonremovelocalhomelidocard,
    Function(TickerProvider)? chatOnInitDetail,
    Function()? chatOnDisposeDetail,
    bool authPluginIsSimpleStyle = false,
    bool authPluginIsWithoutImageBanner = false,
    dynamic googleApiKey,
    FirebaseOptions? firebaseOptions,
    required List<Locale> supportedlocale,
    dynamic setLocale,
    String? vapidKey,
    Function(DioError)? errorInterceptor,
  }) {
    return OOWOOConfigData.raw(
      supportedlocale: supportedlocale,
      baseUrl: baseUrl,
      baseUrlHomelido: baseUrlHomelido,
      baseUrlGeotracking: baseUrlGeotracking,
      mqttUrl: mqttUrl,
      mqttPort: mqttPort,
      mainColor: mainColor,
      onAfterLogin: onAfterLogin,
      appPrefs: appPrefs,
      appColors: appColors,
      isUserVersion: isUserVersion,
      oowooPlatform: oowooPlatform,
      takeFile: takeFile,
      chatgetPreEventByEventId: chatgetPreEventByEventId,
      chatgetDifferentTimePreEventByEventId:
          chatgetDifferentTimePreEventByEventId,
      chatopeninmycalendar: chatopeninmycalendar,
      chatgettitleEvent: chatgettitleEvent,
      chatgetcardColor: chatgetcardColor,
      chatonremovelocalhomelidocard: chatonremovelocalhomelidocard,
      chatOnInitDetail: chatOnInitDetail,
      chatOnDisposeDetail: chatOnDisposeDetail,
      chatgetDistanceBetweenUserAndPlaceByEventId:
          chatgetDistanceBetweenUserAndPlaceByEventId,
      authPluginIsSimpleStyle: authPluginIsSimpleStyle,
      authPluginIsWithoutImageBanner: authPluginIsWithoutImageBanner,
      googleApiKey: googleApiKey,
      firebaseOptions: firebaseOptions,
      setLocale: setLocale,
      vapidKey: vapidKey,
      errorInterceptor: errorInterceptor,
    );
  }

  const OOWOOConfigData.raw({
    required this.baseUrl,
    required this.baseUrlHomelido,
    required this.baseUrlGeotracking,
    required this.mqttUrl,
    required this.mqttPort,
    this.mainColor,
    this.onAfterLogin,
    this.appPrefs,
    this.appColors,
    this.isUserVersion,
    this.oowooPlatform,
    this.takeFile,
    this.chatgetDifferentTimePreEventByEventId,
    this.chatgetDistanceBetweenUserAndPlaceByEventId,
    this.chatgetPreEventByEventId,
    this.chatgetcardColor,
    this.chatgettitleEvent,
    this.chatonremovelocalhomelidocard,
    this.chatOnInitDetail,
    this.chatOnDisposeDetail,
    this.chatopeninmycalendar,
    required this.authPluginIsSimpleStyle,
    required this.supportedlocale,
    this.setLocale,
    this.authPluginIsWithoutImageBanner = false,
    this.googleApiKey,
    this.firebaseOptions,
    this.vapidKey,
    this.errorInterceptor,
  });

  // //End points
  // static const String BASE_URL_GEO = String.fromEnvironment('BASE_URL_GEO',
  //     defaultValue: 'https://preprod-geotracking.arckipel.net/');

  // static const String BASE_URL = String.fromEnvironment('BASE_URL',
  //     defaultValue: 'https://preprod-api.arckipel.net/');

  // static const String BASE_URL_HOMELIDO = String.fromEnvironment(
  //     'BASE_URL_HOMELIDO',
  //     defaultValue: 'https://preprodwww.homelido.com/uploads/');

  final String baseUrl;
  final String baseUrlHomelido;
  final String baseUrlGeotracking;
  final String mqttUrl;
  final int mqttPort;

  final FirebaseOptions? firebaseOptions;
  final String? vapidKey;
  final dynamic googleApiKey;
  final Color? mainColor;
  final Function(bool permissionStatus)? onAfterLogin;
  final dynamic appPrefs;
  final dynamic appColors;
  final bool? isUserVersion;
  final OOWOOPlatform? oowooPlatform;
  final Future<File?> Function(
      {TakeFileType fileType, TakeFileTypeAllow fileTypeAllow})? takeFile;
  final dynamic chatgetPreEventByEventId;
  final dynamic chatgetDifferentTimePreEventByEventId;
  final dynamic chatgetDistanceBetweenUserAndPlaceByEventId;
  final dynamic chatopeninmycalendar;
  final dynamic chatgettitleEvent;
  final dynamic chatgetcardColor;
  final Function(dynamic homelidoId)? chatonremovelocalhomelidocard;
  final Function(TickerProvider)? chatOnInitDetail;
  final Function()? chatOnDisposeDetail;
  final bool authPluginIsSimpleStyle;
  final bool authPluginIsWithoutImageBanner;
  final List<Locale> supportedlocale;
  final dynamic setLocale;
  final Function(DioError)? errorInterceptor;
}

enum TakeFileTypeAllow { image, file }

enum TakeFileType { single, multiple }

class OOWOOConfig extends InheritedTheme {
  const OOWOOConfig({Key? key, required this.data, required this.child})
      : super(key: key, child: child);

  final OOWOOConfigData data;

  @override
  final Widget child;

  static OOWOOConfigData of(BuildContext context) {
    final OOWOOConfig theme =
        context.dependOnInheritedWidgetOfExactType<OOWOOConfig>()!;
    return theme.data;
  }

  @override
  bool updateShouldNotify(OOWOOConfig oldWidget) => data != oldWidget.data;

  @override
  Widget wrap(BuildContext context, Widget child) {
    final OOWOOConfig? ancestorTheme =
        context.findAncestorWidgetOfExactType<OOWOOConfig>();
    return identical(this, ancestorTheme)
        ? child
        : OOWOOConfig(data: data, child: child);
  }
}
