import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:oowoo_core/oowoo_core.dart';

class WidgetSettingSparaterInput extends StatelessWidget {
  const WidgetSettingSparaterInput({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      width: Get.width,
      height: .9,
      color: appColors.settingDividerColor,
      margin: const EdgeInsets.symmetric(vertical: 6),
    );
  }
}

class WidgetSettingInput extends StatefulWidget {
  final TextEditingController controller;
  final FocusNode node;
  final FocusNode? next;
  final String title;
  final String? des;
  final dynamic onSubmitted;
  final bool readOnly;
  const WidgetSettingInput({
    Key? key,
    required this.controller,
    required this.title,
    required this.node,
    this.readOnly = false,
    this.des,
    this.onSubmitted,
    this.next,
  }) : super(key: key);

  @override
  State<WidgetSettingInput> createState() => _WidgetSettingInputState();
}

class _WidgetSettingInputState extends State<WidgetSettingInput> {
  late FocusNode node = widget.node;
  InputBorder get _border => InputBorder.none;

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        const SizedBox(
          height: 4,
        ),
        Text(
          widget.title,
          style: textStyleSmall.copyWith(
              fontSize: 10.0, color: appColors.text),
        ),
        TextFormField(
          onFieldSubmitted: (_) {
            if (widget.next != null) {
              widget.next!.requestFocus();
            } else if (widget.onSubmitted != null) {
              widget.onSubmitted();
            }
          },
          readOnly: widget.readOnly,
          focusNode: node,
          controller: widget.controller,
          cursorColor: appColors.text,
          style: robotoMedium.copyWith(fontSize: 15.0),
          decoration: InputDecoration(
              isCollapsed: true,
              contentPadding: const EdgeInsets.only(top: 6, bottom: 4),
              border: _border,
              focusedBorder: _border,
              enabledBorder: _border),
        ),
        if (widget.des != null)
          Padding(
            padding: const EdgeInsets.only(top: 4),
            child: Text(
              widget.des!,
              style: textStyleSmall.copyWith(
                  fontSize: 10.0, color: appColors.text),
            ),
          ),
      ],
    );
  }
}
