import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:get/get.dart';
import 'package:oowoo_core/oowoo_core.dart';

class WidgetSettingSparater extends StatelessWidget {
  const WidgetSettingSparater({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: const EdgeInsets.only(top: 12, bottom: 12, left: 58),
      width: Get.width,
      height: .8,
      color: appColors.settingDividerColor,
    );
  }
}

class WidgetSettingItemOption extends StatelessWidget {
  final String? icon;
  final String title;
  final String hint;
  final Widget? iconWidget;
  final dynamic onTap;
  const WidgetSettingItemOption({
    Key? key,
    this.icon,
    required this.title,
    required this.hint,
    this.iconWidget,
    this.onTap,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: onTap,
      child: Container(
        color: Colors.transparent,
        padding: const EdgeInsets.symmetric(horizontal: 10),
        child: Row(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            const SizedBox(
              width: 4,
            ),
            Container(
              margin: const EdgeInsets.only(top: 6),
              width: 46,
              child: Align(
                alignment: Alignment.centerLeft,
                child: iconWidget ??
                    SvgPicture.asset(
                      'assets/images/svg/setting/$icon.svg',
                      width: 28,
                    ),
              ),
            ),
            Expanded(
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Text(
                    title,
                    style: rubikMedium.copyWith(fontSize: 15.0),
                  ),
                  const SizedBox(
                    height: 2,
                  ),
                  Text(
                    hint,
                    style: textStyleSmall.copyWith(color: appColors.text),
                  ),
                ],
              ),
            )
          ],
        ),
      ),
    );
  }
}
