import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../oowoo_core.dart';

// class WidgetDraggerBottomsheet extends StatelessWidget {
//   final Color? backgroundColor;
//   final double? borderRadius;
//   final EdgeInsets? padding;
//   final Widget child;
//   WidgetDraggerBottomsheet({
//     Key? key,
//     this.padding,
//     this.backgroundColor,
//     this.borderRadius,
//     required this.child,
//   }) : super(key: key);

//   late ScrollController _scrollController;

//   @override
//   Widget build(BuildContext context) {
//     return DraggableScrollableSheet(
//       expand: true,
//       minChildSize: .75,
//       maxChildSize: .95,
//       initialChildSize: .75,
//       builder: (ctx, scrollController) {
//         _scrollController = scrollController;
//         // scrollController.addListener(() {
//         //   if ((_scrollController.position.extentAfter < 200) && !_isFetching) {
//         //     _fetch();
//         //   }
//         // });

//         return Container(
//           decoration: BoxDecoration(
//             color: backgroundColor ?? Colors.white,
//             borderRadius:
//                 BorderRadius.vertical(top: Radius.circular(borderRadius ?? 16)),
//           ),
//           padding: padding ?? EdgeInsets.zero,
//           child: child,
//         );
//       },
//     );
//   }
// }

class WidgetBottomBarApp extends StatelessWidget {
  final Widget child;
  final double? height;
  final double? width;
  final EdgeInsets? padding;

  WidgetBottomBarApp({
    Key? key,
    required this.child,
    this.width,
    this.padding,
    this.height,
  }) : super(key: key);

  final ScrollController controller = ScrollController();
  bool popped = false;

  @override
  Widget build(BuildContext context) {
    return Material(
      color: Colors.transparent,
      child: NotificationListener(
        onNotification: (n) {
          if (controller.position.pixels < -80 && popped == false) {
            popped = true;
            Get.back();
          }
          return true;
        },
        child: GestureDetector(
          onTap: () {
            Get.back();
          },
          child: SingleChildScrollView(
            controller: controller,
            physics: const BouncingScrollPhysics(),
            child: Container(
              color: Colors.transparent,
              height: Get.height + 1,
              child: Align(
                alignment: Alignment.bottomCenter,
                child: Stack(
                  clipBehavior: Clip.none,
                  children: [
                    Container(
                      margin: EdgeInsets.fromLTRB(
                          8, 0, 8, 16 + MediaQuery.of(context).padding.bottom),
                      height: height,
                      width: width ?? Get.width,
                      clipBehavior: Clip.hardEdge,
                      decoration: BoxDecoration(
                          color:
                              OOWOOTheme.of(context).bottomSheetBacgroudColor,
                          borderRadius: BorderRadius.circular(24)),
                      padding: padding ?? const EdgeInsets.only(top: 24),
                      child: child,
                    ),
                    Positioned(
                      top: -15,
                      left: Get.width / 2 - 30,
                      child: Container(
                        height: 7.5,
                        width: 60,
                        decoration: BoxDecoration(
                            color: OOWOOTheme.of(context).bottomSheetGripColor,
                            borderRadius: BorderRadius.circular(99)),
                      ),
                    )
                  ],
                ),
              ),
            ),
          ),
        ),
      ),
    );
  }
}

class WidgetBottomSheetApp extends StatelessWidget {
  final Widget child;
  final double? height;
  final double? width;
  final EdgeInsets? padding;

  const WidgetBottomSheetApp({
    Key? key,
    required this.child,
    this.width,
    this.padding,
    this.height,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Stack(
      clipBehavior: Clip.none,
      children: [
        Container(
          height: height,
          width: width ?? Get.width,
          clipBehavior: Clip.hardEdge,
          decoration: BoxDecoration(
              color: OOWOOTheme.of(context).bottomSheetBacgroudColor,
              borderRadius: const BorderRadius.only(
                  topLeft: Radius.circular(32), topRight: Radius.circular(32))),
          padding: padding ?? const EdgeInsets.only(top: 24),
          child: child,
        ),
        Positioned(
          top: -15,
          left: Get.width / 2 - 30,
          child: Container(
            height: 7.5,
            width: 60,
            decoration: BoxDecoration(
                color: OOWOOTheme.of(context).bottomSheetGripColor,
                borderRadius: BorderRadius.circular(99)),
          ),
        )
      ],
    );
  }
}
