import 'package:flutter/material.dart';

class WidgetClickable extends StatelessWidget {
  final Widget child;
  final Function()? onTap;
  const WidgetClickable({
    Key? key,
    required this.child,
    this.onTap,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MouseRegion(
      cursor: SystemMouseCursors.click,
      child: GestureDetector(
        onTap: onTap,
        child: child,
      ),
    );
  }
}
